%% ERGO COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1993 by The University of Queensland, Queensland 4072 Australia
%% 
%% 
%% Permission to use, copy and distribute this software for any
%% non-commercial purpose and without fee is hereby granted, provided
%% that the above copyright notice and this permission notice and
%% warranty disclaimer appear in all copies and in supporting
%% documentation, and that the name of the University of Queensland not
%% be used in advertising or publicity pertaining to distribution of
%% the software without specific, written prior permission.
%% 
%% Source code modifications are prohibited except where written 
%% agreement has been given in advance by the University of Queensland.
%% 
%% The University of Queensland disclaims all warranties with regard to
%% this software, including all implied warranties of merchantability
%% and fitness.  In no event shall the University of Queensland be
%% liable for any special, indirect or consequential damages or any
%% damages whatsoever resulting from loss of use, data or profits,
%% whether in an action of contract, negligence or other tortious
%% action, arising out of or in connection with the use or performance
%% of this software.
%% 
%% CVS take_thm.ql,v 1.7 1993/12/10 02:23:48 marku Exp


take_theorem(Name)          :- take_theorem(Name, _, _).
take_theorem(Name, Theorem) :- take_theorem(Name, Theorem, _).

take_theorem(Name, Theorem, No) :-
	check_term(Theorem),
        thawing_new_vars(
            once((
		get_th_or_hyp(Name, Name2, Theorem, Body, Dep),
	        once(Body),
                incomplete_retry_delays
	        ))
	    ),
	assimilate_new_vars([Theorem]),  %% push into get_th_or_hyp ???
        add_hyp(Theorem, No, take_theorem(Name2), Dep).
