%% ERGO COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1993 by The University of Queensland, Queensland 4072 Australia
%% 
%% 
%% Permission to use, copy and distribute this software for any
%% non-commercial purpose and without fee is hereby granted, provided
%% that the above copyright notice and this permission notice and
%% warranty disclaimer appear in all copies and in supporting
%% documentation, and that the name of the University of Queensland not
%% be used in advertising or publicity pertaining to distribution of
%% the software without specific, written prior permission.
%% 
%% Source code modifications are prohibited except where written 
%% agreement has been given in advance by the University of Queensland.
%%
%% The University of Queensland disclaims all warranties with regard to
%% this software, including all implied warranties of merchantability
%% and fitness.  In no event shall the University of Queensland be
%% liable for any special, indirect or consequential damages or any
%% damages whatsoever resulting from loss of use, data or profits,
%% whether in an action of contract, negligence or other tortious
%% action, arising out of or in connection with the use or performance
%% of this software.
%% 
%% CVS fol.ql,v 1.5 1993/12/10 02:21:43 marku Exp



:- tactic(eq_pos(Pos,_),
         ['new_hyp(+Pos) -- use substitutivity to reason about subterm at Pos'],
         ['Opening subterm at ', Pos],
         ['']
         ).

eq_pos(Pos, [Proof]) :-
	is_focus(F),
	eq_sub(F,Pos,x,Template,Inst),
	conjecture(Inst = NewInst, Nr),
	discharge(Nr, ((open_pos([1], (Proof, is_focus(NI))),
			        inst_var(NewInst, NI),
				trans_true(r:reflexeql)))),
	trans_goal(equality, [NewInst/x]*Template, [h(Inst = NewInst)]).



/*
:- tactic(eq_term(Term,_),
         ['new_hyp(+Term) -- use substitutivity to reason about subterms of',nl,
          '                  the focus which match (exactly) Term.'
	 ],
         ['Reasoning about subterm ', Term],
         ['']
         ).

*/


%%
%% eq_sub(+Term, +Pos, +ObjVar, 0Term, 1Term).
%%
%% Reverse substitution, such that
%%
%%  Term = [1Term/ObjVar]*0Term
%%
%% and ObjVar occurs only at position Pos in 0Term,
%%            and is free only in subterms of 0Term which contain Pos
%%


% what does this do??
eq_sub(E,_,_,_,_) :-
        substitute(E, Subs, Term),
        \+ (Subs == []),
        !.

eq_sub(E,[],x,x,E) :-
        !.

eq_sub(E,[P|Pos],x,E2,S) :-
        E =.. EList,
        !,
	length(PreList, P),
	append(PreList, [Arg|PostList], EList),
	eq_sub(Arg, Pos, x, NewArg, S),
    	append(PreList, [NewArg|PostList], NewEList),
	x not_free_in (PreList, PostList),
    	E2 =.. NewEList.


%%
%% Why doesn't this work?
%% 

eq_sub(E,[P|Pos],x,E2,S) :-
	(((P == 2) ; (P = b(V)))),
        quantify(E,Q,V,B),
        quantify(E2,Q,V,B2),
        !,
        x distinct_from V,
        eq_sub(B,Pos,x,B2,S).

