%% ERGO COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1993 by The University of Queensland, Queensland 4072 Australia
%% 
%% 
%% Permission to use, copy and distribute this software for any
%% non-commercial purpose and without fee is hereby granted, provided
%% that the above copyright notice and this permission notice and
%% warranty disclaimer appear in all copies and in supporting
%% documentation, and that the name of the University of Queensland not
%% be used in advertising or publicity pertaining to distribution of
%% the software without specific, written prior permission.
%% 
%% Source code modifications are prohibited except where written 
%% agreement has been given in advance by the University of Queensland.
%% 
%% The University of Queensland disclaims all warranties with regard to
%% this software, including all implied warranties of merchantability
%% and fitness.  In no event shall the University of Queensland be
%% liable for any special, indirect or consequential damages or any
%% damages whatsoever resulting from loss of use, data or profits,
%% whether in an action of contract, negligence or other tortious
%% action, arising out of or in connection with the use or performance
%% of this software.
%% 
%% CVS forwards.ql,v 1.4 1993/12/10 02:18:42 marku Exp


?- op(830,xfy,(=>)).

/*
** Take a hypothesis and do some work on it
*/


forwards(Rule, Form) :-
	th_or_hyp(Rule, TrueForm, R),	
	forwards(Form, TrueForm, R).

forwards(Form, Form, Rule) :-
	take_theorem(Rule, Form).

forwards(Form, X => Form, Rule) :-
	!,
        satisfy(X, List), 
	take_theorem(Rule, X => Form, Hyp),
        h_trans(Hyp, mp, List).


forwards(Form, X => FeqG, Rule) :-
	once((check_eq(Form, G, _, FeqG, _, Pos), 
	      satisfy(X, XList), 
	      satisfy(G, GList))), !,
	take_theorem(Rule, X => FeqG, Hyp),
        h_trans(Hyp, mp, XList),
	focus((h(FeqG), Pos), trans_true(refleximp, GList)).

forwards(Form, TForm, Rule) :-
        once((check_eq(Form, G, E, TForm, _, Pos), 
	      satisfy(G, List))), !,
	take_theorem(Rule, TForm, Hyp),
        focus((Hyp, Pos), trans_true(refleximp, List)).


check_eq(F, G,  E,        Form,          P) :- check_eq(F, G, E, Form, _, P).


check_eq(F, true, _,      F,        t, not_used).
check_eq(F, G,   E,       FeG,      f, [2]) :- FeG =.. [E, F, G], member(E, ['=', '<=>']).
check_eq(F, G,   E,       GeF,      r, [1]) :- GeF =.. [E, G, F], member(E, ['=', '<=>']).
check_eq(F, G,   <=>,     F = G,    f, [2]).
check_eq(F, G,   <=>,     G = F,    r, [1]).






