%% ERGO COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1993 by The University of Queensland, Queensland 4072 Australia
%% 
%% 
%% Permission to use, copy and distribute this software for any
%% non-commercial purpose and without fee is hereby granted, provided
%% that the above copyright notice and this permission notice and
%% warranty disclaimer appear in all copies and in supporting
%% documentation, and that the name of the University of Queensland not
%% be used in advertising or publicity pertaining to distribution of
%% the software without specific, written prior permission.
%% 
%% Source code modifications are prohibited except where written 
%% agreement has been given in advance by the University of Queensland.
%% 
%% The University of Queensland disclaims all warranties with regard to
%% this software, including all implied warranties of merchantability
%% and fitness.  In no event shall the University of Queensland be
%% liable for any special, indirect or consequential damages or any
%% damages whatsoever resulting from loss of use, data or profits,
%% whether in an action of contract, negligence or other tortious
%% action, arising out of or in connection with the use or performance
%% of this software.
%% 
%% CVS induction.ql,v 1.6 1993/12/10 02:18:44 marku Exp


/*
** Useful predicates for induction tactics everywhere
*/


init_code(C, P, I) :- var(P), C = I, !.
init_code(C, call_tac(_, _, P), I) :- var(P), C = I, !.
init_code(P, P, _).



induction_focus(Pred, SVar, [b(SVar), 2]) :-
	is_focus(Pred => _), !.

induction_focus(Pred, SVar, [b(SVar), 2, 2]) :-
	is_focus((Pred and _) => _), !,
	trans_r(antecedents).

induction_focus(Pred, SVar, [b(SVar), 2, 2]) :-
	is_focus(Ant => C),
	once(elem_of_conjunct(Pred, Ant)),
	back(r : strengthen2, _, Pred => (Ant => C), 
		[(open_pos([2], (split_all_hyps, trans_true(h Pred))), trans_true(imp_true))]
	     ).

elem_of_conjunct(A, A) :- !.
elem_of_conjunct(A, A and B) :- !.
elem_of_conjunct(A, C and B) :-
	elem_of_conjunct(A, B).
