%% ERGO COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1993 by The University of Queensland, Queensland 4072 Australia
%% 
%% 
%% Permission to use, copy and distribute this software for any
%% non-commercial purpose and without fee is hereby granted, provided
%% that the above copyright notice and this permission notice and
%% warranty disclaimer appear in all copies and in supporting
%% documentation, and that the name of the University of Queensland not
%% be used in advertising or publicity pertaining to distribution of
%% the software without specific, written prior permission.
%% 
%% Source code modifications are prohibited except where written 
%% agreement has been given in advance by the University of Queensland.
%% 
%% The University of Queensland disclaims all warranties with regard to
%% this software, including all implied warranties of merchantability
%% and fitness.  In no event shall the University of Queensland be
%% liable for any special, indirect or consequential damages or any
%% damages whatsoever resulting from loss of use, data or profits,
%% whether in an action of contract, negligence or other tortious
%% action, arising out of or in connection with the use or performance
%% of this software.
%% 
%% CVS startup.ql,v 1.6 1993/12/10 02:19:09 marku Exp



use_u1 :-
    	new_saved_fact(rule_group / 5),
    	new_saved_fact(split / 3),
    	new_saved_fact(abbreviation / 2),
	new_saved_fact(back_theorem / 3),
        new_local_fact(heuristic/7),  % replaces heuristic/5
        new_local_fact(envir/3),      % replaces heuristics/4.
        new_local_fact(default_envir/1), % replaces heuristics/4.
	new_local_fact(tactic/7),
	set_prover(u1).
	

u1 :-
	in_proof, !,
	(ipLookup(rerun, false) ->
	     (\+ in_macro -> ipSet(ask_theorem, on) ; true)
	;
	     true),
        call_tac(_).

u1 :-  start_interface.


u1(Code) :- call(Code).


/*
** The interpreter you get when you're not in a proof
*/

start_interface :-
    repeat,
	dbms_interface,
    fail.

dbms_interface :- 
    repeat, 
      dbms_prompt(P),
      get_command(P, C),
      dbms_interface(C), 
    (C == undo).


dbms_interface(undo) :- !.
dbms_interface(C) :-
    dbms_command(C),
    once(C), !.

dbms_interface(C) :-
    dbms_ip_command(C),
    once(C), 
    dbms_interface, !,
    fail.

dbms_interface(C) :- 
    (in_macro -> writelist([C, '\n   -']) ; true),
    writeln('(unsuccessful)').


dbms_prompt(['\n\n[', CD, '] : ']) :-
        once((current_dir(CD) ; (CD = 'No theory'))).

dbms_ip_command(C) :-
    functor(C, F, N),
    once(ip_command(F/N)).

dbms_command(C) :-
    functor(C, F, N),
    once((sys_com(F/N) ;
          show_command(F/N) ;
          tactic_command(F/N))).

/*
** subvert the prover
*/

xyzzy :- interpreter.


/*
** 
*/

declare(Command/N) :-
        assert(tactic_command(Command/N)).


