%% ERGO COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1993 by The University of Queensland, Queensland 4072 Australia
%% 
%% 
%% Permission to use, copy and distribute this software for any
%% non-commercial purpose and without fee is hereby granted, provided
%% that the above copyright notice and this permission notice and
%% warranty disclaimer appear in all copies and in supporting
%% documentation, and that the name of the University of Queensland not
%% be used in advertising or publicity pertaining to distribution of
%% the software without specific, written prior permission.
%% 
%% Source code modifications are prohibited except where written 
%% agreement has been given in advance by the University of Queensland.
%% 
%% The University of Queensland disclaims all warranties with regard to
%% this software, including all implied warranties of merchantability
%% and fitness.  In no event shall the University of Queensland be
%% liable for any special, indirect or consequential damages or any
%% damages whatsoever resulting from loss of use, data or profits,
%% whether in an action of contract, negligence or other tortious
%% action, arising out of or in connection with the use or performance
%% of this software.
%% 
%% CVS systac.ql,v 1.5 1993/12/10 02:19:10 marku Exp


/* 
** Legal commands for each of the builtin interpreters
*/

/*
** Add a tactic command - called from within tactic files.
*/

declare(Command/N) :-
        loading(New), !,
        assert_thy(New, tactic_command, [Command,N]).

declare(Command/N) :-
        current_dir(CD), !,
        assert_thy(CD, tactic_command, [Command,N]).

declare(Command/N) :-
        assert(tactic_command(Command, N)).



prover_command(C) :-
    functor(C,F,N),
    once((legal_proof_command(F/N) ; 
	  special_command(F/N) ;
          show_command(F/N) ;
          tactic_command(F, N) ; 
          get_up(tactic_command, [F,N]))). 

/*
** 
*/

sys_tac_prompt :-
        current_dir(CD),
	ipLookup(cw, CW),
	ipLookup(proof_type, Type),
	sys_tac_prompt(Type, CD, CW),
        writeln('---------------------------------------------------------').

sys_tac_prompt(Type, CD, 1) :-
	!, 
	writelist(['\n', CD, '  (', Type, ' - top level)\n']).

sys_tac_prompt(Type, CD, _) :-
	writelist(['\n', CD, '  (', Type, ')\n']).




/*
** 
*/


get_proof_command(C) :-
    sys_tac_prompt,
    get_command([': '], C).


/*
** Cut down sys_tac
*/

sys_tac :- 
	reportWindow,
        get_proof_command(Line),
	\+ (Line == undo),
        (once(sys_tac(Line)) ;
         once(sys_tac)).


sys_tac(close).

sys_tac(A) :-
	once(A), !,
	once(sys_tac).

sys_tac(_) :-
	writeln('unsuccessful'),
	once(sys_tac).

